Module javafx.graphics
Package javafx.scene.effect

# Class InnerShadow

java.lang.Object
javafx.scene.effect.Effect
javafx.scene.effect.InnerShadow

    public class InnerShadow
    extends Effect

A high-level effect that renders a shadow inside the edges of the given content with the specified color, radius, and offset.

Example:

     InnerShadow innerShadow = new InnerShadow();
     innerShadow.setOffsetX(4);
     innerShadow.setOffsetY(4);
     innerShadow.setColor(Color.web("0x3b596d"));

     Text text = new Text();
     text.setEffect(innerShadow);
     text.setX(20);
     text.setY(100);
     text.setText("InnerShadow");
     text.setFill(Color.ALICEBLUE);
     text.setFont(Font.font(null, FontWeight.BOLD, 50));

The code above produces the following:

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type | Property | Description
  --- | --- | ---
  `ObjectProperty<BlurType>` | `blurType` | The algorithm used to blur the shadow.
  `DoubleProperty` | `choke` | The choke of the shadow.
  `ObjectProperty<Color>` | `color` | The shadow `Color`.
  `DoubleProperty` | `height` | The vertical size of the shadow blur kernel.
  `ObjectProperty<Effect>` | `input` | The input for this `Effect`.
  `DoubleProperty` | `offsetX` | The shadow offset in the x direction, in pixels.
  `DoubleProperty` | `offsetY` | The shadow offset in the y direction, in pixels.
  `DoubleProperty` | `radius` | The radius of the shadow blur kernel.
  `DoubleProperty` | `width` | The horizontal size of the shadow blur kernel.

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `InnerShadow()` | Creates a new instance of InnerShadow with default parameters.
  `InnerShadow​(double radius, double offsetX, double offsetY, Color color)` | Creates a new instance of InnerShadow with specified radius, offsetX, offsetY and color.
  `InnerShadow​(double radius, Color color)` | Creates a new instance of InnerShadow with specified radius and color.
  `InnerShadow​(BlurType blurType, Color color, double radius, double choke, double offsetX, double offsetY)` | Creates a new instance of InnerShadow with the specified blurType, color, radius, spread, offsetX and offsetY.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `ObjectProperty<BlurType>` | `blurTypeProperty()` | The algorithm used to blur the shadow.
  `DoubleProperty` | `chokeProperty()` | The choke of the shadow.
  `ObjectProperty<Color>` | `colorProperty()` | The shadow `Color`.
  `BlurType` | `getBlurType()` | Gets the value of the property blurType.
  `double` | `getChoke()` | Gets the value of the property choke.
  `Color` | `getColor()` | Gets the value of the property color.
  `double` | `getHeight()` | Gets the value of the property height.
  `Effect` | `getInput()` | Gets the value of the property input.
  `double` | `getOffsetX()` | Gets the value of the property offsetX.
  `double` | `getOffsetY()` | Gets the value of the property offsetY.
  `double` | `getRadius()` | Gets the value of the property radius.
  `double` | `getWidth()` | Gets the value of the property width.
  `DoubleProperty` | `heightProperty()` | The vertical size of the shadow blur kernel.
  `ObjectProperty<Effect>` | `inputProperty()` | The input for this `Effect`.
  `DoubleProperty` | `offsetXProperty()` | The shadow offset in the x direction, in pixels.
  `DoubleProperty` | `offsetYProperty()` | The shadow offset in the y direction, in pixels.
  `DoubleProperty` | `radiusProperty()` | The radius of the shadow blur kernel.
  `void` | `setBlurType​(BlurType value)` | Sets the value of the property blurType.
  `void` | `setChoke​(double value)` | Sets the value of the property choke.
  `void` | `setColor​(Color value)` | Sets the value of the property color.
  `void` | `setHeight​(double value)` | Sets the value of the property height.
  `void` | `setInput​(Effect value)` | Sets the value of the property input.
  `void` | `setOffsetX​(double value)` | Sets the value of the property offsetX.
  `void` | `setOffsetY​(double value)` | Sets the value of the property offsetY.
  `void` | `setRadius​(double value)` | Sets the value of the property radius.
  `void` | `setWidth​(double value)` | Sets the value of the property width.
  `DoubleProperty` | `widthProperty()` | The horizontal size of the shadow blur kernel.

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Property Details

  - ### input

    public final ObjectProperty<Effect> inputProperty
    The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null
    See Also:
      `getInput()`, `setInput(Effect)`

  - ### radius

    public final DoubleProperty radiusProperty
    The radius of the shadow blur kernel. This attribute controls the distance that the shadow is spread to each side of the source pixels. Setting the radius is equivalent to setting both the `width` and `height` attributes to a value of `(2 * radius + 1)`.

               Min:   0.0
               Max: 127.0
           Default:  10.0
          Identity:   0.0

    Default value:
      10.0
    See Also:
      `getRadius()`, `setRadius(double)`

  - ### width

    public final DoubleProperty widthProperty
    The horizontal size of the shadow blur kernel. This attribute controls the horizontal size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

               Min:   0.0
               Max: 255.0
           Default:  21.0
          Identity:  <1.0

    Default value:
      21.0
    See Also:
      `getWidth()`, `setWidth(double)`

  - ### height

    public final DoubleProperty heightProperty
    The vertical size of the shadow blur kernel. This attribute controls the vertical size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

               Min:   0.0
               Max: 255.0
           Default:  21.0
          Identity:  <1.0

    Default value:
      21.0
    See Also:
      `getHeight()`, `setHeight(double)`

  - ### blurType

    public final ObjectProperty<BlurType> blurTypeProperty
    The algorithm used to blur the shadow.

               Min: n/a
               Max: n/a
           Default: BlurType.THREE_PASS_BOX
          Identity: n/a

    Default value:
      THREE_PASS_BOX
    See Also:
      `getBlurType()`, `setBlurType(BlurType)`

  - ### choke

    public final DoubleProperty chokeProperty
    The choke of the shadow. The choke is the portion of the radius where the contribution of the source material will be 100%. The remaining portion of the radius will have a contribution controlled by the blur kernel. A choke of `0.0` will result in a distribution of the shadow determined entirely by the blur algorithm. A choke of `1.0` will result in a solid growth inward of the shadow from the edges to the limit of the radius with a very sharp cutoff to transparency inside the radius.

               Min: 0.0
               Max: 1.0
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getChoke()`, `setChoke(double)`

  - ### color

    public final ObjectProperty<Color> colorProperty
    The shadow `Color`.

               Min: n/a
               Max: n/a
           Default: Color.BLACK
          Identity: n/a

    Default value:
      BLACK
    See Also:
      `getColor()`, `setColor(Color)`

  - ### offsetX

    public final DoubleProperty offsetXProperty
    The shadow offset in the x direction, in pixels.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getOffsetX()`, `setOffsetX(double)`

  - ### offsetY

    public final DoubleProperty offsetYProperty
    The shadow offset in the y direction, in pixels.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getOffsetY()`, `setOffsetY(double)`

- ## Constructor Details

  - ### InnerShadow

    public InnerShadow()
    Creates a new instance of InnerShadow with default parameters.

  - ### InnerShadow

    public InnerShadow​(double radius, Color color)
    Creates a new instance of InnerShadow with specified radius and color.
    Parameters:
      `radius` - the radius of the shadow blur kernel
      `color` - the shadow `Color`

  - ### InnerShadow

    public InnerShadow​(double radius, double offsetX, double offsetY, Color color)
    Creates a new instance of InnerShadow with specified radius, offsetX, offsetY and color.
    Parameters:
      `radius` - the radius of the shadow blur kernel
      `offsetX` - the shadow offset in the x direction
      `offsetY` - the shadow offset in the y direction
      `color` - the shadow `Color`

  - ### InnerShadow

    public InnerShadow​(BlurType blurType, Color color, double radius, double choke, double offsetX, double offsetY)
    Creates a new instance of InnerShadow with the specified blurType, color, radius, spread, offsetX and offsetY.
    Parameters:
      `blurType` - the algorithm used to blur the shadow
      `color` - the shadow `Color`
      `radius` - the radius of the shadow blur kernel
      `choke` - the portion of the radius where the contribution of the source material will be 100%
      `offsetX` - the shadow offset in the x direction
      `offsetY` - the shadow offset in the y direction
    Since:
      JavaFX 2.1

- ## Method Details

  - ### setInput

    public final void setInput​(Effect value)
    Sets the value of the property input.
    Property description:
      The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null

  - ### getInput

    public final Effect getInput()
    Gets the value of the property input.
    Property description:
      The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null

  - ### inputProperty

    public final ObjectProperty<Effect> inputProperty()
    The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null
    See Also:
      `getInput()`, `setInput(Effect)`

  - ### setRadius

    public final void setRadius​(double value)
    Sets the value of the property radius.
    Property description:
      The radius of the shadow blur kernel. This attribute controls the distance that the shadow is spread to each side of the source pixels. Setting the radius is equivalent to setting both the `width` and `height` attributes to a value of `(2 * radius + 1)`.

                 Min:   0.0
                 Max: 127.0
             Default:  10.0
            Identity:   0.0

    Default value:
      10.0

  - ### getRadius

    public final double getRadius()
    Gets the value of the property radius.
    Property description:
      The radius of the shadow blur kernel. This attribute controls the distance that the shadow is spread to each side of the source pixels. Setting the radius is equivalent to setting both the `width` and `height` attributes to a value of `(2 * radius + 1)`.

                 Min:   0.0
                 Max: 127.0
             Default:  10.0
            Identity:   0.0

    Default value:
      10.0

  - ### radiusProperty

    public final DoubleProperty radiusProperty()
    The radius of the shadow blur kernel. This attribute controls the distance that the shadow is spread to each side of the source pixels. Setting the radius is equivalent to setting both the `width` and `height` attributes to a value of `(2 * radius + 1)`.

               Min:   0.0
               Max: 127.0
           Default:  10.0
          Identity:   0.0

    Default value:
      10.0
    See Also:
      `getRadius()`, `setRadius(double)`

  - ### setWidth

    public final void setWidth​(double value)
    Sets the value of the property width.
    Property description:
      The horizontal size of the shadow blur kernel. This attribute controls the horizontal size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

                 Min:   0.0
                 Max: 255.0
             Default:  21.0
            Identity:  <1.0

    Default value:
      21.0

  - ### getWidth

    public final double getWidth()
    Gets the value of the property width.
    Property description:
      The horizontal size of the shadow blur kernel. This attribute controls the horizontal size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

                 Min:   0.0
                 Max: 255.0
             Default:  21.0
            Identity:  <1.0

    Default value:
      21.0

  - ### widthProperty

    public final DoubleProperty widthProperty()
    The horizontal size of the shadow blur kernel. This attribute controls the horizontal size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

               Min:   0.0
               Max: 255.0
           Default:  21.0
          Identity:  <1.0

    Default value:
      21.0
    See Also:
      `getWidth()`, `setWidth(double)`

  - ### setHeight

    public final void setHeight​(double value)
    Sets the value of the property height.
    Property description:
      The vertical size of the shadow blur kernel. This attribute controls the vertical size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

                 Min:   0.0
                 Max: 255.0
             Default:  21.0
            Identity:  <1.0

    Default value:
      21.0

  - ### getHeight

    public final double getHeight()
    Gets the value of the property height.
    Property description:
      The vertical size of the shadow blur kernel. This attribute controls the vertical size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

                 Min:   0.0
                 Max: 255.0
             Default:  21.0
            Identity:  <1.0

    Default value:
      21.0

  - ### heightProperty

    public final DoubleProperty heightProperty()
    The vertical size of the shadow blur kernel. This attribute controls the vertical size of the total area over which the shadow of a single pixel is distributed by the blur algorithm. Values less than `1.0` are not distributed beyond the original pixel and so have no blurring effect on the shadow.

               Min:   0.0
               Max: 255.0
           Default:  21.0
          Identity:  <1.0

    Default value:
      21.0
    See Also:
      `getHeight()`, `setHeight(double)`

  - ### setBlurType

    public final void setBlurType​(BlurType value)
    Sets the value of the property blurType.
    Property description:
      The algorithm used to blur the shadow.

                 Min: n/a
                 Max: n/a
             Default: BlurType.THREE_PASS_BOX
            Identity: n/a

    Default value:
      THREE_PASS_BOX

  - ### getBlurType

    public final BlurType getBlurType()
    Gets the value of the property blurType.
    Property description:
      The algorithm used to blur the shadow.

                 Min: n/a
                 Max: n/a
             Default: BlurType.THREE_PASS_BOX
            Identity: n/a

    Default value:
      THREE_PASS_BOX

  - ### blurTypeProperty

    public final ObjectProperty<BlurType> blurTypeProperty()
    The algorithm used to blur the shadow.

               Min: n/a
               Max: n/a
           Default: BlurType.THREE_PASS_BOX
          Identity: n/a

    Default value:
      THREE_PASS_BOX
    See Also:
      `getBlurType()`, `setBlurType(BlurType)`

  - ### setChoke

    public final void setChoke​(double value)
    Sets the value of the property choke.
    Property description:
      The choke of the shadow. The choke is the portion of the radius where the contribution of the source material will be 100%. The remaining portion of the radius will have a contribution controlled by the blur kernel. A choke of `0.0` will result in a distribution of the shadow determined entirely by the blur algorithm. A choke of `1.0` will result in a solid growth inward of the shadow from the edges to the limit of the radius with a very sharp cutoff to transparency inside the radius.

                 Min: 0.0
                 Max: 1.0
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### getChoke

    public final double getChoke()
    Gets the value of the property choke.
    Property description:
      The choke of the shadow. The choke is the portion of the radius where the contribution of the source material will be 100%. The remaining portion of the radius will have a contribution controlled by the blur kernel. A choke of `0.0` will result in a distribution of the shadow determined entirely by the blur algorithm. A choke of `1.0` will result in a solid growth inward of the shadow from the edges to the limit of the radius with a very sharp cutoff to transparency inside the radius.

                 Min: 0.0
                 Max: 1.0
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### chokeProperty

    public final DoubleProperty chokeProperty()
    The choke of the shadow. The choke is the portion of the radius where the contribution of the source material will be 100%. The remaining portion of the radius will have a contribution controlled by the blur kernel. A choke of `0.0` will result in a distribution of the shadow determined entirely by the blur algorithm. A choke of `1.0` will result in a solid growth inward of the shadow from the edges to the limit of the radius with a very sharp cutoff to transparency inside the radius.

               Min: 0.0
               Max: 1.0
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getChoke()`, `setChoke(double)`

  - ### setColor

    public final void setColor​(Color value)
    Sets the value of the property color.
    Property description:
      The shadow `Color`.

                 Min: n/a
                 Max: n/a
             Default: Color.BLACK
            Identity: n/a

    Default value:
      BLACK

  - ### getColor

    public final Color getColor()
    Gets the value of the property color.
    Property description:
      The shadow `Color`.

                 Min: n/a
                 Max: n/a
             Default: Color.BLACK
            Identity: n/a

    Default value:
      BLACK

  - ### colorProperty

    public final ObjectProperty<Color> colorProperty()
    The shadow `Color`.

               Min: n/a
               Max: n/a
           Default: Color.BLACK
          Identity: n/a

    Default value:
      BLACK
    See Also:
      `getColor()`, `setColor(Color)`

  - ### setOffsetX

    public final void setOffsetX​(double value)
    Sets the value of the property offsetX.
    Property description:
      The shadow offset in the x direction, in pixels.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### getOffsetX

    public final double getOffsetX()
    Gets the value of the property offsetX.
    Property description:
      The shadow offset in the x direction, in pixels.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### offsetXProperty

    public final DoubleProperty offsetXProperty()
    The shadow offset in the x direction, in pixels.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getOffsetX()`, `setOffsetX(double)`

  - ### setOffsetY

    public final void setOffsetY​(double value)
    Sets the value of the property offsetY.
    Property description:
      The shadow offset in the y direction, in pixels.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### getOffsetY

    public final double getOffsetY()
    Gets the value of the property offsetY.
    Property description:
      The shadow offset in the y direction, in pixels.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### offsetYProperty

    public final DoubleProperty offsetYProperty()
    The shadow offset in the y direction, in pixels.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getOffsetY()`, `setOffsetY(double)`